
import java.io.*;
import java.net.*;
import java.util.*;

class BCComTest
{
	private Socket localConnect;
	private DataInputStream in;
	private DataOutputStream out;

	public void test0450(String ip, int port,String reg_no, String bc_cust_no, String flag)
	{
		port = 2100;
        ip = "10.1.1.8";
		try {
			System.out.println("1ip : " + ip + "port : " + port);
			localConnect = new Socket(ip, port);
			System.out.println("2ip : " + ip + "port : " + port);
			in = new DataInputStream(localConnect.getInputStream());
			out = new DataOutputStream(localConnect.getOutputStream());
		} catch (Exception ex) {
			System.out.println("Error");
			ex.printStackTrace();
			return;
		}

System.out.println("Socket open success..!!");

		BCComData bcdata = new BCComData();

		// Headerغ
		bcdata.setTransCode("123456789");
		bcdata.setTextStartChar("BCA");
		bcdata.setMsgCode("0450");
		bcdata.setTransSeq("123456789012");
		bcdata.setTransDate("20000929230001");
		bcdata.setRspCode("12");
		bcdata.setMemberCode("65");
		bcdata.setSize(0);

		// Dataغ
		byte[] data = new byte[940];
		for(int i=0; i< data.length ; i++)
			data[i] = (byte)' ';

		String arg = "1" + reg_no +  "01" +  
					formatBCCardNO(bc_cust_no) +  
					"                              " + flag;		 
		
		byte[] data1 = arg.getBytes();
		for (int i =0; i < data1.length; i++)
			data[i] = data1[i];

		bcdata.setData(0,data,0,data.length);
		bcdata.setSize(data.length);

		System.out.println("Send to Server==>");
		BCComUtil.hexaDump(System.out,bcdata.toByte(),
					BCComDef.BCComDataHeadSize+bcdata.getSize());
		if (sendBCComData(bcdata) != true ) {
			System.out.println("Send Error");
			return;
		}

		bcdata = recvBCComData();
		if (bcdata ==null) {
			System.out.println("Recv Error");
			return;
		}


		bcdata = recvBCComData(bcdata,0,940);
		byte[] buffer = bcdata.getData();
		bcdata.setSize(940);

		System.out.println("Recv from Server<<==");
		BCComUtil.hexaDump(System.out,bcdata.toByte(),
					BCComDef.BCComDataHeadSize+bcdata.getSize());
		System.out.println("String Type===\n" + new String(bcdata.toByte()) );
	}

	public void test0440(String ip, int port,String national_reg_no)
	{
System.out.println("ip " + ip + " port " + port);
		try {
			localConnect = new Socket(ip,port);
			in = new DataInputStream(localConnect.getInputStream());
			out = new DataOutputStream(localConnect.getOutputStream());
		} catch (Exception ex) {
			System.out.println("Error");
			return;
		}

System.out.println("0440 open success..!!");

		BCComData bcdata = new BCComData();

		bcdata.setTransCode("123456789");
		bcdata.setTextStartChar("BCA");
		bcdata.setMsgCode("0440");
		bcdata.setTransSeq("123456789012");
		bcdata.setTransDate("20000929230001");
		bcdata.setRspCode("12");
		bcdata.setMemberCode("65");
		bcdata.setSize(0);

		String data = "1" + national_reg_no;
		byte[] buffer = data.getBytes();
		bcdata.setData(0,buffer,0,buffer.length);
		bcdata.setSize(buffer.length);

		System.out.println("Send to Server==>");
		BCComUtil.hexaDump(System.out,bcdata.toByte(),
					BCComDef.BCComDataHeadSize+bcdata.getSize());
		if (sendBCComData(bcdata) != true ) {
			System.out.println("Send Error");
			return;
		}

		bcdata = recvBCComData();
		if (bcdata ==null) {
			System.out.println("Recv Error");
			return;
		}


		bcdata = recvBCComData(bcdata,0,926);
		buffer = bcdata.getData();
		bcdata.setSize(926);

		System.out.println("Recv from Server<<==");
		BCComUtil.hexaDump(System.out,bcdata.toByte(),
					BCComDef.BCComDataHeadSize+bcdata.getSize());
		System.out.println("String Type===\n" + new String(bcdata.toByte()) );

	}

	public static void main(String[] argv)
	{

		if (argv.length < 3) {
		 System.out.println("Usage java BCComTest ip port ŷȣ " +
							"ֹιȣ ȸȸȣ /");
			System.exit(1);
		}

		System.out.println("Server/Client Comm. Test");
		BCComTest test = new BCComTest();
		if (argv[2].compareTo("0440") == 0 ) {
			if (argv.length != 4) { 
				System.out.println("Usage Error");System.exit(1);
			}
			test.test0440(argv[0], Integer.parseInt(argv[1]),argv[3]);
		} else if (argv[2].compareTo("0450") == 0) {
			if (argv.length != 6) { 
				System.out.println("Usage Error");System.exit(1);
			}
			test.test0450(argv[0], Integer.parseInt(argv[1]),argv[3],argv[4],argv[5]);
		} else {
			System.out.println("ŷȣ̻");System.exit(1);
		}
	}

	//
	// BCComData Head б
	//	
	BCComData recvBCComData()
	{
		byte[] buffer  = new byte[BCComDef.BCComDataSize];
		BCComData bcdata= null;
		int	datalen;

		try {
			in.readFully(buffer,0,BCComDef.BCComDataHeadSize);
			bcdata = BCComData.toObject(buffer);
			if (bcdata == null) return null;
			bcdata.setSize(0);

		} catch (InterruptedIOException ex) {
			return null;	
		} catch (IOException ex){
			return null;
		}


		return bcdata;
	}

	//
	// BCComData Data б
	//	
	BCComData recvBCComData(BCComData bccom,int offset,int length) 
	{
		System.out.println("RECV" + length);
		byte[] buffer = new byte[BCComDef.BCComDataSize];
		try 
		{
			in.readFully(buffer,0,length);
			bccom.setData(offset,buffer,0,length);
			bccom.setSize(offset+length);
		} catch (InterruptedIOException ex) {
			return null;	
		} catch (IOException ex){
			return null;
		}
		return bccom;
	}


	boolean sendBCComData(BCComData bcdata)
	{
		byte[] buffer = bcdata.toByte();

		try {
			out.write(buffer,0,BCComDef.BCComDataHeadSize+bcdata.getSize());
		} catch (IOException ex) {
			return false;	
		}
		return true;
	}

	String formatBCCardNO(String cardno) 
	{
		int len = cardno.length();
		String tmp = cardno;

		for (int i=0; i< 12-len; i ++)
		{
			tmp += ' ';	
		}

		return tmp;
	}

}
