import java.io.*;
import java.net.*;

class COMRIF implements Runnable
{
	InfoMgr infoMgr;
	String ip;
	int    port;
	int    upperIdx;
	
	//
	//
	//
	COMRIF(InfoMgr infotab, String ip, int port)
	{
		
		infoMgr = infotab;
		this.ip = ip;
		this.port = port;
		this.upperIdx = -1;

	}

	//
	//
	//
	boolean init()
	{
		if (infoMgr.riftab.en[upperIdx].isConnect == true )
			return true;

		synchronized(infoMgr.riftab.en[upperIdx]) 
		{
			infoMgr.log.writeLog("Starting[" + upperIdx + "] Make Upper Connection(" +ip+","+port+")...");
			try {
        	    infoMgr.log.writeLog("lim_log - ip:" + ip + " port:" + port);	
				infoMgr.riftab.en[upperIdx].connect = new Socket(ip,port);
       		    infoMgr.log.writeLog("lim_log connect success!");	
				infoMgr.riftab.en[upperIdx].in = 
				new DataInputStream(infoMgr.riftab.en[upperIdx].connect.getInputStream());
            	infoMgr.riftab.en[upperIdx].out = 
				new DataOutputStream(infoMgr.riftab.en[upperIdx].connect.getOutputStream());
            	infoMgr.riftab.en[upperIdx].isConnect = true;
        	} catch (Exception ex) {
	       		infoMgr.log.writeLog("Server Connection Error");
           	    infoMgr.log.writeLog("lim_log - catch:" + ex.toString());	
				return false;
			}
			infoMgr.log.writeLog("Connected[" + upperIdx + "]");            		
		}		
		return true;
	}
	
	public void run()
	{
		BCComData bcdata = new BCComData();
		int 	  datasize = 0;
		String   msgCode = null;
		String   transSeq = null;

		// get a empty slot in riftab
		upperIdx = infoMgr.findRIFTabEmptySlot();
		if (upperIdx < 0 ) {
			infoMgr.log.writeLog("[RIF] RIFTab No Empty Slot");
			return;
		}
		
		while(true) 
		{
			
			// Connectó 
			while(init() != true) {
				BCComUtil.sleep(5);
			   // infoMgr.log.writeLog("lim_test sleep start!!");	
			//	BCComUtil.sleep(10);		//lim(2003/05/12)
			 //   infoMgr.log.writeLog("lim_test sleep end!!");	

			}
			
			// Data Input ó
			while(true)
			{
				
				// κ Ÿ .
				int len = infoMgr.recvUpper(bcdata,upperIdx);
			    infoMgr.log.writeLog("lim len: " + len);	 
				if (len < 0) {
					infoMgr.log.writeLog("[RIF" + upperIdx + "] DISC");
					infoMgr.discRIFConn(upperIdx);
					break;
				} else if (len == 0) {
					infoMgr.log.writeLog("[RIF" + upperIdx +"] Size=0 ");	
					continue;	
				}	
				
				// ޽ Ȯ 						
				msgCode = bcdata.getMsgCode();
				transSeq = bcdata.getTransSeq();
				if (msgCode.compareTo("0441") == 0) {
					datasize = 990 - BCComDef.BCComDataHeadSize;
				} 
				else if (msgCode.compareTo("0451") == 0) 
				{
					datasize = 1004 - BCComDef.BCComDataHeadSize;
					//## for debug -s
					//continue;
					//## for debug -e
				}
				else 
				{
					datasize = 0;
					infoMgr.log.writeLog("[RIF" + upperIdx +
										 "] MsgCode Abnoraml MsgCode["+
						                  msgCode+"] Seq["+transSeq+"]");
					continue;
				}

				
				if (datasize != bcdata.getSize() )
				{
					infoMgr.log.writeLog("[RIF" + upperIdx + 
						  "] Size Unmatched RecvSize["+
						  bcdata.getSize()+"] ReqSize[" +datasize+ "]" +
						  "Seq[" + transSeq +"]");
					continue;
				}
				
				
				// ϴ 
				int nrifID = infoMgr.sendLow(bcdata);

				if (nrifID < 0 )
				{
					infoMgr.log.writeLog("[RIF" + upperIdx + "] IF DISC Or Seq[" +
						  transSeq + "] Unmatched ID["+nrifID+"] ");
				}
				else 	// 
				{
					infoMgr.log.writeLog("Send Client OK  Seq[" + transSeq +
					  "] ID["+nrifID+ "]");
				}

				//## debug -s
				infoMgr.log.objDump(bcdata);
				//## debug -e

			} // end-while
		
		} // end-while
			
		
	} // end-method
} //end-class
