import java.io.*;
import java.net.*;

class COMRIF implements Runnable
{
	InfoMgr infoMgr;
	String ip;
	int    port;
	
	//
	//
	//
	COMRIF(InfoMgr infotab, String ip, int port)
	{
		
		infoMgr = infotab;
		this.ip = ip;
		this.port = port;

	}

	//
	//
	//
	boolean init()
	{
		if (infoMgr.riftab.isConnect == true )
			return true;

		synchronized(infoMgr.riftab) 
		{
			infoMgr.log.writeLog("Starting Make Upper Connection(" +ip+","+port+")...");
			try {
				infoMgr.riftab.connect = new Socket(ip,port);
            			infoMgr.riftab.in = new DataInputStream(infoMgr.riftab.connect.getInputStream());
            			infoMgr.riftab.out = new DataOutputStream(infoMgr.riftab.connect.getOutputStream());
            			infoMgr.riftab.isConnect = true;
        		} catch (Exception ex) {
	            		infoMgr.log.writeLog("Server Connection Error");
            			return false;
			}
			infoMgr.log.writeLog("Connected");            		
		}		
		return true;
	}
	
	public void run()
	{
		BCComData bcdata = new BCComData();
		int 	  datasize = 0;
		String   msgCode = null;
		String   transSeq = null;
		
		while(true) 
		{
			
			// Connectó 
			while(init() != true) {
				BCComUtil.sleep(5);
			}
			
			// Data Input ó
			while(true)
			{
				
				// κ Ÿ .
				int len = infoMgr.recvUpper(bcdata);
				if (len < 0) {
					infoMgr.log.writeLog("[RIF] DISC");
					infoMgr.discRIFConn();
					break;
				} else if (len == 0) {
					infoMgr.log.writeLog("[RIF] Size[0]");	
					continue;	
				}	
				
				// ޽ Ȯ 						
				msgCode = bcdata.getMsgCode();
				transSeq = bcdata.getTransSeq();
				if (msgCode.compareTo("0441") == 0) {
					datasize = 990 - BCComDef.BCComDataHeadSize;
				} 
				else if (msgCode.compareTo("0451") == 0) 
				{
					datasize = 1004 - BCComDef.BCComDataHeadSize;
					//## for debug -s
					//continue;
					//## for debug -e
				}
				else 
				{
					datasize = 0;
					infoMgr.log.writeLog("[RIF] MsgCode Abnoraml MsgCode["+
						   msgCode+"] Seq["+transSeq+"]");
					continue;
				}

				
				if (datasize != bcdata.getSize() )
				{
					infoMgr.log.writeLog("[RIF] Size Unmatched RecvSize["+
						  bcdata.getSize()+"] ReqSize[" +datasize+ "]" +
						  "Seq[" + transSeq +"]");
					continue;
				}
				
				
				// ϴ 
				int nrifID = infoMgr.sendLow(bcdata);

				if (nrifID < 0 )
				{
					infoMgr.log.writeLog("[RIF] IF DISC Or Seq[" +
						  transSeq + "] Unmatched ID["+nrifID+"] ");
				}
				else 	// 
				{
					infoMgr.log.writeLog("Send Client OK  Seq[" + transSeq +
					  "] ID["+nrifID+ "]");
				}

				//## debug -s
				infoMgr.log.objDump(bcdata);
				//## debug -e

			} // end-while
		
		} // end-while
			
		
	} // end-method
} //end-class
